/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.57 Revision 1.60
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.57 2008/04/21 02:56:34 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.60 2008/05/15 14:03:15 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
97 { 97 {
98 echo "VDRPLUGIN_DB=1" 98 echo "VDRPLUGIN_DB=1"
99 echo "CREATOR=ECLASS" 99 echo "CREATOR=ECLASS"
100 echo "EBUILD=${CATEGORY}/${PN}" 100 echo "EBUILD=${CATEGORY}/${PN}"
101 echo "EBUILD_V=${PVR}" 101 echo "EBUILD_V=${PVR}"
102 echo "PLUGINS=\"$@\""
102 } > "${D}/${DB_FILE}" 103 } > "${D}/${DB_FILE}"
103} 104}
104 105
105# Delete files created outside of vdr-plugin.eclass 106# Delete files created outside of vdr-plugin.eclass
106# vdrplugin-rebuild.ebuild converted plugindb and files are 107# vdrplugin-rebuild.ebuild converted plugindb and files are
130create_header_checksum_file() 131create_header_checksum_file()
131{ 132{
132 # Danger: Not using $ROOT here, as compile will also not use it !!! 133 # Danger: Not using $ROOT here, as compile will also not use it !!!
133 # If vdr in $ROOT and / differ, plugins will not run anyway 134 # If vdr in $ROOT and / differ, plugins will not run anyway
134 135
136 local CHKSUM="header-md5-vdr"
137
138 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
139 cp "${VDR_CHECKSUM_DIR}/header-md5-vdr" "${CHKSUM}"
140 elif type -p md5sum >/dev/null 2>&1; then
141 (
142 cd "${VDR_INCLUDE_DIR}"
143 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
144 ) > "${CHKSUM}"
145 else
146 die "Could not create md5 checksum of headers"
147 fi
148
135 insinto "${VDR_CHECKSUM_DIR}" 149 insinto "${VDR_CHECKSUM_DIR}"
136 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 150 local p_name
137 newins "${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}" 151 for p_name; do
138 else 152 newins "${CHKSUM}" "header-md5-${p_name}"
139 if type -p md5sum >/dev/null 2>&1; then 153 done
140 cd "${S}"
141 (
142 cd "${VDR_INCLUDE_DIR}"
143 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
144 ) > header-md5-${PN}
145 doins header-md5-${PN}
146 fi
147 fi
148} 154}
149 155
150fix_vdr_libsi_include() 156fix_vdr_libsi_include()
151{ 157{
152 einfo "Fixing include of libsi-headers" 158 einfo "Fixing include of libsi-headers"
161vdr_patchmakefile() { 167vdr_patchmakefile() {
162 einfo "Patching Makefile" 168 einfo "Patching Makefile"
163 [[ -e Makefile ]] || die "Makefile of plugin can not be found!" 169 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
164 cp Makefile "${WORKDIR}"/Makefile.before 170 cp Makefile "${WORKDIR}"/Makefile.before
165 171
172 # plugin makefiles use VDRDIR in strange ways
173 # assumptions:
174 # 1. $(VDRDIR) contains Make.config
175 # 2. $(VDRDIR) contains config.h
176 # 3. $(VDRDIR)/include/vdr contains the headers
177 # 4. $(VDRDIR) contains main vdr Makefile
178 # 5. $(VDRDIR)/locale exists
179 # 6. $(VDRDIR) allows to access vdr source files
180 #
181 # We only have one directory (for now /usr/include/vdr),
182 # that contains vdr-headers and Make.config.
183 # To satisfy 1-3 we do this:
184 # Set VDRDIR=/usr/include/vdr
185 # Set VDRINCDIR=/usr/include
186 # Change $(VDRDIR)/include to $(VDRINCDIR)
187
166 ebegin " Setting Pathes" 188 ebegin " Setting Pathes"
167 sed -i Makefile \ 189 sed -i Makefile \
168 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \ 190 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
169 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \ 191 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
170 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \ 192 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
171 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \ 193 \
172 -e "/^DVBDIR/d" \
173 -e 's:-I$(DVBDIR)/include::' 194 -e 's:-I$(DVBDIR)/include::' \
195 -e 's:-I$(DVBDIR)::'
174 eend $? 196 eend 0
175 197
176 # maybe needed for multiproto: 198 # maybe needed for multiproto:
177 #sed -i Makefile \ 199 #sed -i Makefile \
178 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 200 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
179 # -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
180 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' 201 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
181 202
182 if ! grep -q APIVERSION Makefile; then 203 if ! grep -q APIVERSION Makefile; then
183 ebegin " Converting to APIVERSION" 204 ebegin " Converting to APIVERSION"
184 sed -i Makefile \ 205 sed -i Makefile \
277 if plugin_has_gettext; then 298 if plugin_has_gettext; then
278 einfo "Plugin has gettext support, fine" 299 einfo "Plugin has gettext support, fine"
279 else 300 else
280 vdr_i18n_convert_to_gettext 301 vdr_i18n_convert_to_gettext
281 if [[ $? != 0 ]]; then 302 if [[ $? != 0 ]]; then
282 ewarn "" 303 eerror ""
283 ewarn "Plugin will have only english OSD texts" 304 eerror "Plugin will have only english OSD texts"
284 ewarn "it needs manual fixing." 305 eerror "it needs manual fixing."
285 fi 306 fi
286 fi 307 fi
287 else 308 else
288 einfo "VDR has no gettext support" 309 einfo "VDR has no gettext support"
289 if plugin_has_gettext; then 310 if plugin_has_gettext; then
295vdr-plugin_copy_source_tree() { 316vdr-plugin_copy_source_tree() {
296 pushd . >/dev/null 317 pushd . >/dev/null
297 cp -r "${S}" "${T}"/source-tree 318 cp -r "${S}" "${T}"/source-tree
298 cd "${T}"/source-tree 319 cd "${T}"/source-tree
299 cp "${WORKDIR}"/Makefile.before Makefile 320 cp "${WORKDIR}"/Makefile.before Makefile
321 # TODO: Fix this, maybe no longer needed
300 sed -i Makefile \ 322 sed -i Makefile \
301 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 323 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
302 -e 's:^CXXFLAGS:#CXXFLAGS:' \ 324 -e 's:^CXXFLAGS:#CXXFLAGS:' \
303 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \ 325 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
304 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):' 326 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
338 360
339 # Pathes to includes 361 # Pathes to includes
340 VDR_INCLUDE_DIR="/usr/include/vdr" 362 VDR_INCLUDE_DIR="/usr/include/vdr"
341 DVB_INCLUDE_DIR="/usr/include" 363 DVB_INCLUDE_DIR="/usr/include"
342 364
343
344 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale" 365 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
345 LOCDIR="/usr/share/vdr/locale" 366 LOCDIR="/usr/share/vdr/locale"
367
368 TMP_LIBDIR="${WORKDIR}/tmp-libdir"
346 369
347 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 370 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
348 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 371 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
349 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 372 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
350 373
407 eerror "Please report this at bugs.gentoo.org." 430 eerror "Please report this at bugs.gentoo.org."
408 die "vdr-plugin_src_unpack not called!" 431 die "vdr-plugin_src_unpack not called!"
409 fi 432 fi
410 cd "${S}" 433 cd "${S}"
411 434
435 mkdir -p "${TMP_LIBDIR}"
412 emake ${BUILD_PARAMS} \ 436 emake ${BUILD_PARAMS} \
413 ${VDRPLUGIN_MAKE_TARGET:-all} \ 437 ${VDRPLUGIN_MAKE_TARGET:-all} \
414 LOCALEDIR="${TMP_LOCALE_DIR}" \ 438 LOCALEDIR="${TMP_LOCALE_DIR}" \
439 LIBDIR="${TMP_LIBDIR}" \
440 TMPDIR="${T}" \
415 || die "emake failed" 441 || die "emake failed"
416 ;; 442 ;;
417 esac 443 esac
418 444
419 shift 445 shift
440 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 466 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
441 doins "${mname}.patched" 467 doins "${mname}.patched"
442 468
443 fi 469 fi
444 470
445 cd "${S}" 471
472 local p_list="" p_name
473
474 cd "${TMP_LIBDIR}"
475 for p in libvdr-*.so.*; do
476 p_name="${p%.so*}"
477 p_name="${p_name#lib}"
478 p_list="${p_list} ${p_name}"
479
446 insinto "${VDR_PLUGIN_DIR}" 480 insinto "${VDR_PLUGIN_DIR}"
447 doins libvdr-*.so.* 481 doins "$p"
482 done
483
484 create_header_checksum_file ${p_list}
485 create_plugindb_file ${p_list}
448 486
449 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then 487 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
450 einfo "Installing locales" 488 einfo "Installing locales"
451 cd "${TMP_LOCALE_DIR}" 489 cd "${TMP_LOCALE_DIR}"
452 insinto "${LOCDIR}" 490 insinto "${LOCDIR}"
472 510
473 if [[ -n ${VDR_RCADDON_FILE} ]]; then 511 if [[ -n ${VDR_RCADDON_FILE} ]]; then
474 insinto "${VDR_RC_DIR}" 512 insinto "${VDR_RC_DIR}"
475 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 513 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
476 fi 514 fi
477
478 create_header_checksum_file
479 create_plugindb_file
480} 515}
481 516
482vdr-plugin_pkg_postinst() { 517vdr-plugin_pkg_postinst() {
483 vdr-plugin_print_enable_command 518 vdr-plugin_print_enable_command
484 519

Legend:
Removed from v.1.57  
changed lines
  Added in v.1.60

  ViewVC Help
Powered by ViewVC 1.1.20